#include	"circbuf.cls"

void	CircularBuffer::Add(const char _FAR c)
{
	if (_Full)
	{
		Error=2;
		return;
	}
	if(!Initialised)
	{
		Error=4;
		return;
	}
	else
	{
		Buffer[Start]=c;
		Start=(Start+1)%_Size;
		if (Start==Finish) _Full=TRUE;
		_Empty=FALSE;
		Error=0;
	}
}
const int _FAR CircularBuffer::ReSize(const int _FAR n)
{
	if(!_Empty)
	{
		Error=5;
		return _Size;
	}
	else
	{
		if(n)
		{
			if(Initialised)
			{
				delete [] Buffer;
				Initialised=FALSE;
			}
			return Size(n);
		}
		else
		{
			Error=6;
			return _Size;
		}
	}
}

#if 0

template <class T>
const char * CircularBuffer<T>::messages[]={
	"No Error",
	"Failed initialisation",
	"Buffer Full",
	"Buffer Empty",
	"Not Initialised",
	"Buffer must be Empty to use ReSize",
	"Cannot ReSize to ZERO"
	};

#else

const char *CircularBuffer::messages[]={
	"No Error",
	"Failed initialisation",
	"Buffer Full",
	"Buffer Empty",
	"Not Initialised",
	"Buffer must be Empty to use ReSize",
	"Cannot ReSize to ZERO"
	};

#endif

#ifdef	_CIRCBUFTEST

#include	<stdio.h>

void	main(void)
{
	CircularBuffer	Buffer;
	int	i=Buffer.Size(0);
	int	E=Buffer.ErrorCode();
	printf("Expect:No Error. Actual:%s\n",Buffer.ErrorMessage());
	i=Buffer.Size(5);
	Buffer.Add('A');
	E=Buffer.ErrorCode();
	Buffer.Add('B');
	E=Buffer.ErrorCode();
	Buffer.Add('C');
	E=Buffer.ErrorCode();
	Buffer.Add('D');
	E=Buffer.ErrorCode();
	Buffer.Add('E');
	E=Buffer.ErrorCode();
	Buffer.Add('F');
	E=Buffer.ErrorCode();
	printf("Expect:Buffer Full. Actual:%s\n",Buffer.ErrorMessage());
	char c=Buffer.Remove();
	printf("Expect:No Error. Actual:%s\n",Buffer.ErrorMessage());
	E=Buffer.ErrorCode();
	c=Buffer.Remove();
	E=Buffer.ErrorCode();
	c=Buffer.Remove();
	E=Buffer.ErrorCode();
	c=Buffer.Remove();
	E=Buffer.ErrorCode();
	c=Buffer.Remove();
	E=Buffer.ErrorCode();
	c=Buffer.Remove();
	E=Buffer.ErrorCode();
	printf("Expect:Buffer Empty. Actual:%s\n",Buffer.ErrorMessage());
	c=Buffer.Remove();
	E=Buffer.ErrorCode();
	printf("Expect:Buffer Empty. Actual:%s\n",Buffer.ErrorMessage());
	c=Buffer.Remove();
	E=Buffer.ErrorCode();
	Buffer.Add('H');
	E=Buffer.ErrorCode();
	printf("Expect:No Error. Actual:%s\n",Buffer.ErrorMessage());
	i=Buffer.ReSize(10);
	E=Buffer.ErrorCode();
	printf("Expect:Buffer must be Empty to use ReSize.\nActual:%s\n",
											Buffer.ErrorMessage());
	Buffer.Flush();
	printf("Expect:No Error. Actual:%s\n",Buffer.ErrorMessage());
	i=Buffer.ReSize(10);
	printf("Expect:No Error. Actual:%s\n",Buffer.ErrorMessage());
	E=Buffer.ErrorCode();
	Buffer.Flush();
	printf("Expect:No Error. Actual:%s\n",Buffer.ErrorMessage());
	i=Buffer.ReSize(0);
	printf("Expect:Cannot ReSize to ZERO. Actual:%s\n",Buffer.ErrorMessage());
	E=Buffer.ErrorCode();
	E=Buffer.ErrorCode();
}

#endif
